﻿Option Strict On
Option Explicit On

'O:\Beispiele\Type\IConvertibleBigInteger\IConvertibleBigInteger.sln

Imports System.Text
Imports System.Numerics
''' <summary>
''' Modified BigInteger
''' </summary>
''' <history>© exc-jdbi 2017</history>
<System.Diagnostics.DebuggerStepThrough()> _
Public Structure Bignum
    Implements IConvertible
    Public Property value As BigInteger
    <System.Diagnostics.DebuggerHidden()> _
    Public Function GetTypeCode() As TypeCode Implements IConvertible.GetTypeCode
        Return Nothing
    End Function
    <System.Diagnostics.DebuggerHidden()> _
    Public Function ToBoolean(ByVal provider As IFormatProvider) As Boolean Implements IConvertible.ToBoolean
        Return Nothing
    End Function
    <System.Diagnostics.DebuggerHidden()> _
    Public Function ToByte(ByVal provider As IFormatProvider) As Byte Implements IConvertible.ToByte
        Return CByte(Me.value)
    End Function
    <System.Diagnostics.DebuggerHidden()> _
    Public Function ToChar(ByVal provider As IFormatProvider) As Char Implements IConvertible.ToChar
        Return Nothing
    End Function
    <System.Diagnostics.DebuggerHidden()> _
    Public Function ToDateTime(ByVal provider As IFormatProvider) As Date Implements IConvertible.ToDateTime
        Return Nothing
    End Function
    <System.Diagnostics.DebuggerHidden()> _
    Public Function ToDecimal(ByVal provider As IFormatProvider) As Decimal Implements IConvertible.ToDecimal
        Return CDec(Me.value)
    End Function
    <System.Diagnostics.DebuggerHidden()> _
    Public Function ToDouble(ByVal provider As IFormatProvider) As Double Implements IConvertible.ToDouble
        Return CDbl(Me.value)
    End Function
    <System.Diagnostics.DebuggerHidden()> _
    Public Function ToInt16(ByVal provider As IFormatProvider) As Short Implements IConvertible.ToInt16
        Return CType(Me.value, Int16)
    End Function
    <System.Diagnostics.DebuggerHidden()> _
    Public Function ToInt32(ByVal provider As IFormatProvider) As Int32 Implements IConvertible.ToInt32
        Return CInt(Me.value)
    End Function
    <System.Diagnostics.DebuggerHidden()> _
    Public Function ToInt64(ByVal provider As IFormatProvider) As Int64 Implements IConvertible.ToInt64
        Return CType(Me.value, Int64)
    End Function
    <System.Diagnostics.DebuggerHidden()> _
    Public Function ToSByte(ByVal provider As IFormatProvider) As SByte Implements IConvertible.ToSByte
        Return CType(Me.value, SByte)
    End Function
    <System.Diagnostics.DebuggerHidden()> _
    Public Function ToSingle(ByVal provider As IFormatProvider) As Single Implements IConvertible.ToSingle
        Return CType(Me.value, Single)
    End Function
    <System.Diagnostics.DebuggerHidden()> _
    Public Function ToString1(ByVal provider As IFormatProvider) As String Implements IConvertible.ToString
        Return Nothing
    End Function
    <System.Diagnostics.DebuggerHidden()> _
    Public Function ToType(ByVal conversionType As Type, ByVal provider As IFormatProvider) As Object Implements IConvertible.ToType
        Return Me
    End Function
    <System.Diagnostics.DebuggerHidden()> _
    Public Function ToUInt16(ByVal provider As IFormatProvider) As UShort Implements IConvertible.ToUInt16
        Return CType(Me.value, UInt16)
    End Function
    <System.Diagnostics.DebuggerHidden()> _
    Public Function ToUInt32(ByVal provider As IFormatProvider) As UInt32 Implements IConvertible.ToUInt32
        Return CType(Me.value, UInt32)
    End Function
    <System.Diagnostics.DebuggerHidden()> _
    Public Function ToUInt64(ByVal provider As IFormatProvider) As UInt64 Implements IConvertible.ToUInt64
        Return CType(Me.value, UInt64)
    End Function
    <System.Diagnostics.DebuggerHidden()> _
    Public Sub New(ByVal val As BigInteger)
        Me.value = val
    End Sub
    <System.Diagnostics.DebuggerHidden()> _
    Public Sub New(ByVal val As Bignum)
        Me.value = val.value
    End Sub
    <System.Diagnostics.DebuggerHidden()> _
    Public Sub New(ByVal valu As Object)
        If valu.GetType = GetType(BigInteger) Then
            Me.value = CType(valu, BigInteger)
        Else : Me.value = New BigInteger(Val(valu))
        End If
    End Sub
End Structure