﻿'www.vb-paradise.de/index.php/User/23082-exc-jdbi/
'
'github.com/exc-jdbi
'
'Is Free and Opensource

Option Strict On
Option Explicit On
Imports System.Numerics
Public Module ModMain
    Public Sub Main()
        Dim cnt As Int32 = 250
        Dim sw As New Stopwatch
        Dim rnd As New CryptoRnd

        Dim bArr() As Byte = New Byte(cnt - 1) {}
        Dim iArr() As Int32 = New Int32(cnt - 1) {}
        Dim dArr() As Double = New Double(cnt - 1) {}
        Dim uiArr() As UInt64 = New UInt64(cnt - 1) {}
        PrintTitel()

        'Cryptosichere Random-Arrays mit min/max (Ganzzahlen-Datentypen)
        '***************************************************************
        'Datentype Int32
        Dim min As Int32 = Int32.MinValue, max As Int32 = Int32.MaxValue
        sw.Start()
        If rnd.Interval(Of Int32)(min, max) Then
            rnd.GetRnds(Of Int32)(iArr)
        End If
        sw.Stop()
        Dim sw1 As Int64 = sw.ElapsedMilliseconds
        PrintOut(iArr, sw)

        'Datentype UInt64
        Dim max2 As UInt64 = UInt64.MaxValue, min2 As UInt64 = CULng(10 ^ 18)
        sw.Restart()
        If rnd.Interval(Of UInt64)(min2, max2) Then
            rnd.GetRnds(Of UInt64)(uiArr)
        End If
        sw.Stop()
        Dim sw2 As Int64 = sw.ElapsedMilliseconds
        PrintOut(uiArr, sw, True)

        'Datentype Byte
        Dim min3 As Byte = Byte.MinValue, max3 As Byte = Byte.MaxValue
        sw.Restart()
        rnd.GetRnds(Of Byte)(bArr, min3, max3)
        sw.Stop()
        Dim sw3 As Int64 = sw.ElapsedMilliseconds
        PrintOut(bArr, sw)

        'Cryptosichere Random-Arrays (Double-Datentypen)
        '***********************************************
        'Datentype Double ohne Interval ==> GetRndsDbl()
        'Alle Werte [>=0,<=1]
        sw.Restart()
        rnd.GetRndsDbl(dArr)
        sw.Stop()
        Dim sw4 As Int64 = sw.ElapsedMilliseconds
        PrintOut(dArr, sw)


        'Cryptosichere RndStrings
        '************************
        sw.Restart()
        Dim sRndAlpha As String = rnd.GetRndAlpha(cnt)
        sw.[Stop]()
        Dim sw5 As Int64 = sw.ElapsedMilliseconds

        sw.Restart()
        Dim sRndAscii As String = rnd.GetRndAscii(cnt)
        sw.[Stop]()
        Dim sw6 As Int64 = sw.ElapsedMilliseconds


        'Cryptosichere Random-Array Primes (Natürliche Zahlen)
        '*****************************************************
        Dim uiArrPrimes() As UInt64 = New UInt64(cnt - 1) {}
        Dim uiArrPrimes2() As Byte = New Byte(cnt - 1) {}
        'Dim min4 As SByte = 0 : Dim max4 As SByte = SByte.MaxValue
        Dim min4 As UInt64 = CULng(10 ^ 18) : Dim max4 As UInt64 = UInt64.MaxValue

        sw.Restart()
        If rnd.Interval(Of UInt64)(min4, max4) Then
            rnd.GetRndPrimes(Of UInt64)(uiArrPrimes)
        End If
        sw.Stop()
        Dim sw7 As Int64 = sw.ElapsedMilliseconds
        PrintOut(uiArrPrimes, sw)

        sw.Restart()
        rnd.GetRndPrimes(Of Byte)(uiArrPrimes2, 0, Byte.MaxValue)
        sw.Stop()
        Dim sw8 As Int64 = sw.ElapsedMilliseconds
        PrintOut(uiArrPrimes2, sw)


        'Einzelne cryptosichere Randoms mit min/max (Ganzzahlige Datentypen)
        '*******************************************************************
        Dim iRnd As Int32 = rnd.Next(Of Int32)(-100, 100)
        Dim ulRnd As UInt64 = rnd.Next(Of UInt64)(1000, 123456789)
        Dim blRnd As Byte = rnd.Next(Of Byte)(100, 200)

        'Für einzelne cryptosichere Double-Randoms ==> NextDbl() ohne Interval
        'Werte [>=0,<=1]
        Dim dRnd As Double = rnd.NextDbl()

        'Primes: Wichtig min/max >=0
        Dim iRng As Int32 = rnd.NextPrime(15, 899)


        'KonsolenAusgabe Zeiten
        '**********************
        PrintFinish()
        Console.WriteLine("{0}Secure Randoms:", vbCrLf)
        PrintOut(iArr, sw1)
        PrintOut(uiArr, sw2)
        PrintOut(bArr, sw3)
        PrintOut(dArr, sw4)
        Console.WriteLine("{0}Secure Randoms String:", vbCrLf)
        PrintOut(sRndAlpha.ToCharArray(), sw5)
        PrintOut(sRndAscii.ToCharArray(), sw6)
        Console.WriteLine("{0}Secure Randoms Prime:", vbCrLf)
        PrintOut(uiArrPrimes, sw7)
        PrintOut(uiArrPrimes2, sw8)

        Console.ReadKey()
    End Sub

    'KonsolenAusgabe
    Private Sub PrintFinish()
        Console.WriteLine("Finish" & vbTab & "************************************************************" & vbCr & vbLf)
    End Sub
    Private Sub PrintTitel()
        Console.WriteLine("Cryptographically strong Randomgenerator{0}****************************************{0}", vbCrLf)
    End Sub
    Private Sub PrintOut(Of T)(ByVal arr() As T, ByVal sww As Int64)
        Dim typ As Type = arr(0).GetType
        Console.WriteLine("{3}{1}{0}pcs.:{1}{2}ms.", arr.Length, vbTab, sww, typ.ToString)
    End Sub
    Private Sub PrintOut(Of T)(ByVal arr() As T, ByVal sww As Stopwatch, Optional ByVal _checkodd As Boolean = False)
        Dim typ As Type = arr(0).GetType()
        Dim bi1 As BigInteger
        For i As Int32 = 0 To arr.Length - 1
            If _checkodd Then
                bi1 = CType(Math.Abs(Val(arr(i))), BigInteger)
                If bi1 = UInt64.MaxValue Then Stop
                If (Not bi1 Mod 2 = 0) Then Stop
            End If
            Console.WriteLine(arr(i))
        Next
        Console.WriteLine("{3}{4}{1}{0}pcs.:{1}{2}ms.{3}{3}", arr.Length, vbTab, sww.ElapsedMilliseconds, vbCrLf, typ.ToString)
    End Sub
End Module
